<?php

	define('TOOL_REGISTRY_NAME','weToolsRegistry');
	
	class weToolLookup {
		
		
		function weToolLookup() {
			
		}
		
		function getAllTools($force=false) {
						
			if(!$force && !defined("NO_SESS") && isset($_SESSION[TOOL_REGISTRY_NAME]['meta'])) {
				return $_SESSION[TOOL_REGISTRY_NAME]['meta'];
			}
			
			$_tools = array();
			
			$_toolsDirs = array();

			$_ignore = array('','.','..','cvs','cache','search','first_steps_wizard','Suche');
			$_bd = $_SERVER['DOCUMENT_ROOT'] . '/webEdition/we/include/we_tools';
			$_d = opendir($_bd);
			
			while( $_entry = readdir($_d) ){
				if( !in_array(strtolower($_entry),$_ignore) && is_dir($_bd . '/' . $_entry)){
					$_toolsDirs[] = $_bd . '/' . $_entry;
				}
			}
			closedir($_d);
			
			foreach ($_toolsDirs as $_toolDir) {
				$_metaFile = $_toolDir . '/conf/meta.conf.php';
				if(file_exists($_metaFile)) {
					include($_metaFile);
					if(isset($metaInfo)) {

						include($_bd . '/' . $metaInfo['name'] . '/language/language_' . $GLOBALS['WE_LANGUAGE'] . '.inc.php');
						$metaInfo['text'] = ${'l_' . $metaInfo['name']}[$metaInfo['name']];
						$_tools[] = $metaInfo;
						unset($metaInfo);
					}
				}
			}
			
			if(!defined("NO_SESS")) {
				$_SESSION[TOOL_REGISTRY_NAME]['meta'] = $_tools;
			}
	
			return $_tools;
			
		}
		
		function getAllCustomTools() {
			$_tools = weToolLookup::getAllTools();
			$_builtin = array('toolfactory','navigation','Suche');
			$_custom = array();
			foreach ($_tools as $_tool) {
				if(!in_array($_tool['name'],$_builtin)){
					$_custom[] = $_tool;
				}
			}
			return $_custom;
		}
		
		
		function getToolProperties($name) {
			
			$_tools = weToolLookup::getAllTools(true);
			foreach ($_tools as $_tool) {
				if($_tool['name']==$name) {
					return $_tool;
				}
			}
			return array();
			
			
		}
		
		
		function  getPhpCmdInclude() {
						
			$_inc = '';
			if(isset($_REQUEST['we_cmd'][0])) {
				$_tools = weToolLookup::getAllTools();
				foreach($_tools as $_tool){
					if(eregi("^tool_" . $_tool['name'] . "_",$_REQUEST['we_cmd'][0])){
						$_REQUEST['tool'] = $_tool['name'];
						$_inc='we_tools/'.$_tool['name'].'/hook/we_phpCmdHook_' . $_tool['name'] . '.inc.php';
						break;
					}
				}
			}

			return $_inc;
		}
		
		function getJsCmdInclude() {

			$_inc = array();
			$_tools = weToolLookup::getAllTools();
			foreach($_tools as $_tool){
				if(file_exists($_SERVER['DOCUMENT_ROOT'] . '/webEdition/we/include/we_tools/' . $_tool['name'] . '/hook/we_jsCmdHook_' . $_tool['name'] . '.inc.php')){
					$_inc[] = $_SERVER['DOCUMENT_ROOT'] . '/webEdition/we/include/we_tools/' . $_tool['name'] . '/hook/we_jsCmdHook_' . $_tool['name'] . '.inc.php';
				}
			}

			return $_inc;
		}
		
		function getDefineInclude() {
			
			if(!defined("NO_SESS") && isset($_SESSION[TOOL_REGISTRY_NAME]['defineinclude'])) {
				return $_SESSION[TOOL_REGISTRY_NAME]['defineinclude'];
			}
			
			$_inc = array();
			$_tools = weToolLookup::getAllTools();
			foreach($_tools as $_tool){
				if(file_exists($_SERVER['DOCUMENT_ROOT'] . '/webEdition/we/include/we_tools/' . $_tool['name'] . '/conf/define.conf.php')){
					$_inc[] = $_SERVER['DOCUMENT_ROOT'] . '/webEdition/we/include/we_tools/' . $_tool['name'] . '/conf/define.conf.php';
				}
			}
			if(!defined("NO_SESS")) {
				$_SESSION[TOOL_REGISTRY_NAME]['defineinclude'] = $_inc;
			}
				
			return $_inc;
		}
		
		function isTool($name) {
			$_tools = weToolLookup::getAllTools();
			foreach ($_tools as $_tool) {
				if($_tool['name']==$name) {
					return true;
				}
			}
			return in_array($name,$_tools);
			
		}
		
		function getCmdInclude($namespace,$name,$cmd) {
			return WE_TOOLS_DIR . $name . '/service/cmds'. $namespace . 'rpc' . $cmd . 'Cmd.class.php';
		}
		
		function getViewInclude($protocol,$namespace,$name,$view) {
			
			return WE_TOOLS_DIR . $name . '/service/views/' . $this->Protocol . $namespace . 'rpc' . $view . 'View.class.php';
			
		}
		
		function getAllToolTags($toolname) {
			
			return weToolLookup::getFileRegister($toolname,'/tags',"^we_tag_",'we_tag_','.inc.php');
						
		}
		
		
		function getAllToolServices($toolname) {

			return weToolLookup::getFileRegister($toolname,'/service/cmds',"^rpc",'rpc','Cmd.class.php');
			
		}
		
		function getAllToolLanguages($toolname) {

			return weToolLookup::getFileRegister($toolname,'/language',"^language_",'language_','.inc.php');
			
		}
		
		function getFileRegister($toolname,$subdir,$filematch,$rem_before='',$rem_after='') {
			$_founds = array();
			
			$_tooldir = WE_TOOLS_DIR . $toolname . $subdir;
			if(weToolLookup::isTool($toolname) && is_dir($_tooldir)) {
				$_d = opendir($_tooldir);
				while( $_entry = readdir($_d) ){
					if(!is_dir($_tooldir . '/' . $_entry) && eregi($filematch,$_entry)){
						$_tagname = str_replace($rem_before,'',$_entry);
						$_tagname = str_replace($rem_after,'',$_tagname);
						$_founds[$_tagname] = $_tooldir . '/' . $_entry;
					}
				}
				closedir($_d);
			}
			return $_founds;
		}
		
		
		function getToolTag($name,&$include) {
			$_tools = weToolLookup::getAllTools();
			foreach ($_tools as $_tool) {
				if(file_exists(WE_TOOLS_DIR . $_tool['name'] . '/tags/we_tag_' . $name . '.inc.php')) {
					$include = WE_TOOLS_DIR . $_tool['name'] . '/tags/we_tag_' . $name . '.inc.php';
					return true;
				}
			}
			return false;
		}
		
		function getPermissionIncludes() {
			$_inc = array();
			$_tools = weToolLookup::getAllTools();
			foreach($_tools as $_tool){
				if(file_exists($_SERVER['DOCUMENT_ROOT'] . '/webEdition/we/include/we_tools/' . $_tool['name'] . '/conf/permission.conf.php')){
					$_inc[] = $_SERVER['DOCUMENT_ROOT'] . '/webEdition/we/include/we_tools/' . $_tool['name'] . '/conf/permission.conf.php';
				}
			}

			return $_inc;
		}

		function getLanguageInclude($name) {
			return WE_TOOLS_DIR . $name . '/language/language_' . $GLOBALS['WE_LANGUAGE'] . '.inc.php';
		}
		
		function getToolsForBackup() {
			$_inc = array();
			$_tools = weToolLookup::getAllTools();
			foreach($_tools as $_tool){
				if(file_exists($_SERVER['DOCUMENT_ROOT'] . '/webEdition/we/include/we_tools/' . $_tool['name'] . '/conf/backup.conf.php')){
					$_inc[] = $_tool['name'];
				}
			}
			return $_inc;
		}
		
		function getBackupTables($name) {
			if(file_exists(WE_TOOLS_DIR . $name . '/conf/backup.conf.php')) {
				include(WE_TOOLS_DIR . $name . '/conf/backup.conf.php');
				if (!empty($toolTables)) {
					return $toolTables;
				}
			}
			return array();
		}
		
		
		function getFilesOfDir(&$allFiles, $baseDir) {

			if (file_exists($baseDir)) {
	
				$dh = opendir($baseDir);
				while( $entry = readdir($dh) ){
	
					if( $entry != "" && $entry != "." && $entry != ".."){
	
						$_entry = $baseDir . "/" . $entry;
	
			            if( !is_dir( $_entry ) ){
			                $allFiles[] = $_entry;
			            }
	
						if(is_dir( $_entry ) && strtolower(strtolower($entry)!="cvs") ){
							weToolLookup::getFilesOfDir( $allFiles, $_entry);
						}
					}
				}
				closedir($dh);
			}

		}
		
		function getDirsOfDir(&$allDirs, $baseDir) {

			if (file_exists($baseDir)) {
	
				$dh = opendir($baseDir);
				while( $entry = readdir($dh) ){
	
					if( $entry != "" && $entry != "." && $entry != ".."  && strtolower($entry!="cvs")){
	
						$_entry = $baseDir . "/" . $entry;
	
			            if( is_dir( $_entry ) ){
			                $allDirs[] = $_entry;
			                weToolLookup::getDirsOfDir( $allDirs, $_entry);
			            }

					}
				}
				closedir($dh);
			}

		}		
		
		function getIgnoreList() {
			return  array('doctype','category','navigation','toolfactory','Suche');
		}
		
		function isInIgnoreList($toolname) {
			$_ignore = weToolLookup::getIgnoreList();
			return in_array($toolname,$_ignore);
			
		}
		
			function getModelClassName($name) {
			
			$_tool = weToolLookup::getToolProperties($name);
			
			if(!empty($_tool)) {
				
				return $_tool['classname'];
				
			}
			
			return '';			
		}

	}


?>