<?php

// +----------------------------------------------------------------------+
// | webEdition                                                           |
// +----------------------------------------------------------------------+
// | PHP version 4.1.0 or greater                                         |
// +----------------------------------------------------------------------+
// | Copyright (c) 2000 - 2007 living-e AG                                |
// +----------------------------------------------------------------------+
//

/**
 * @abstract class which provides new functions and overwrites functions from
 * class "we_search" for creating search by means of SQL-Statements
 * @author Thomas Kneip
 * @copyright Copyright (c) 2000 - 2007, living-e AG
 * @since 5.1.0.0 - 14.10.2007
 */

/**
 * @abstract include base search class
 */
include_once($_SERVER["DOCUMENT_ROOT"]."/webEdition/we/include/we_classes/"."we_search.inc.php");

/**
* @abstract include language file for doclist
*/
include_once($_SERVER["DOCUMENT_ROOT"]."/webEdition/we/include/we_language/".$GLOBALS["WE_LANGUAGE"]."/doclist.inc.php");



class doclistSearch extends we_search {
	
	/**
	 * @var integer: number of searchfield-rows
	 */
	var $height;
	
	/**
	 * @var string: default order of the result columns
	 */
	var $order = "Text";
	
	/**
	 * @var string: default number of rows of the result columns
	 */
	var $anzahl = 25;
	
	/**
	 * @var string: mode if the searchfields are displayed or not, default = 0 (not displayed)
	 */
	var $mode = 0;
	
	/**
	 * @var string: set view, either iconview (1) or listview (0, default)
	 */
	var $setView = 0;
	
	/**
	 * @var array with fields to search in
	 */
	var $searchFields = array();
	
	/**
	 * @var array with operators
	 */
	var $location = array();
	
	/**
	 * @var array with fields to search for
	 */
	var $search = array();
	
	
	/**
	 * @abstract get data from fields
	 */
	function initSearchData(){

		if ( isset( $_REQUEST["searchstart"] ) ) {
			$GLOBALS['we_doc']->searchclassFolder->searchstart = ($_REQUEST["searchstart"]);
		}
		if ( isset( $_REQUEST["setView"] ) ) {
			$this->query("UPDATE ". FILE_TABLE ." SET listview=".$_REQUEST['setView']." WHERE ID=".$GLOBALS['we_doc']->ID."");
			$GLOBALS['we_doc']->searchclassFolder->setView = ($_REQUEST["setView"]);
		}
		else {
			$GLOBALS['we_doc']->searchclassFolder->setView = f("SELECT listview FROM ".FILE_TABLE." WHERE ID='".$GLOBALS['we_doc']->ID."'","listview",$GLOBALS["DB_WE"]);
		}
		if ( isset( $_REQUEST["mode"] ) ) {
			$GLOBALS['we_doc']->searchclassFolder->mode = ($_REQUEST["mode"]);
		}
		if ( isset( $_REQUEST["order"] ) ) {
			$GLOBALS['we_doc']->searchclassFolder->order = ($_REQUEST["order"]);
		}
		if ( isset( $_REQUEST["anzahl"] ) ) {
			$GLOBALS['we_doc']->searchclassFolder->anzahl = ($_REQUEST["anzahl"]);
		}
		if ( isset( $_REQUEST["searchFields"] ) ) {
			$GLOBALS['we_doc']->searchclassFolder->searchFields = ($_REQUEST["searchFields"]);
			$GLOBALS['we_doc']->searchclassFolder->height = count($_REQUEST["searchFields"]);
		}
		else {
			$GLOBALS['we_doc']->searchclassFolder->height = 0;
		}
		if ( isset( $_REQUEST["location"] ) ) {
			$GLOBALS['we_doc']->searchclassFolder->location = ($_REQUEST["location"]);
		}
		if ( isset( $_REQUEST["search"] ) ) {
			$GLOBALS['we_doc']->searchclassFolder->search = ($_REQUEST["search"]);
		}
	}

	/**
	 * @abstract executes a SQL-query for the search
	 */
	function searchquery($where = "",$get="*",$table="",$order="",$limit=""){

			$this->table = (empty($table))?((empty($this->table))?"":$this->table):$table;

			if(!empty($this->table)){
				$this->where = (empty($where))?((empty($this->where))?"":" WHERE ".$this->where):" WHERE ".$where;
				
				if(stristr($this->order, "Text")) {
					$this->get = "*, LOWER(Text) AS lowtext, ABS(REPLACE(Text,'info','')) AS Nr, (Text REGEXP '^[0-9]') AS isNr"; 
					if(stristr($this->order, "DESC")) {
						$order = " ORDER BY IsFolder,isNr,Nr DESC,lowtext DESC ";
					}
					else {
						$order = " ORDER BY IsFolder DESC,isNr DESC,Nr,lowtext";
					}
				}
				else {
					$this->get =  (empty($get))?((empty($this->get))?"*":$this->get):$get;
					$this->order = (!empty($order))?$order:$this->order;
					$order = ((empty($this->order))?"":" ORDER BY IsFolder DESC, ".$this->order);
				}
				
				$this->limit = " ".$this->searchstart.",".$this->anzahl." ";
				$this->limit = (empty($limit))?((empty($this->limit))?"":" LIMIT ".$this->limit):" LIMIT ".$limit;
				
				$this->query("SELECT ".ereg_replace('^(.+),$','\1',$this->get)." FROM ".$this->table." ".$this->where." ".$order." ".$this->limit);
				
			}else{
				return -1;
			}
	}

	/**
	 * @abstract extends the WHERE-string when searching for ParentID
	 * @param folder-ID
	 * @return string  
	 */
	function ofFolderOnly($folderID) {
	
		return ' AND ParentID = '.$folderID;
		
	}
	
	/**
	 * @abstract creates select for location operators
	 * @return string  
	 */
	function getLocation($name="locationField",$select="",$size=1,$sprach=array(),$disabled="disabled"){
	// get Class
	global $l_object;
			$opts = "";
			$loc = array("CONTAIN","IS","START","END","<","<=",">=",">");
			for($i=0;$i<sizeof($loc);$i++){
						$opts .= '<option value="'.$loc[$i].'" '.(($select==$loc[$i])?"selected":"").'>'
						      . htmlspecialchars($GLOBALS['l_we_doclist'][$loc[$i]])
						      . '</option>'."\n";
			}

	return '<select name="'.$name.'" id="'.$name.'" size="'.$size.'" '.$disabled.'>'.$opts.'</select>';
	}
	
}
?>