<?php
// +----------------------------------------------------------------------+
// | webEdition                                                           |
// +----------------------------------------------------------------------+
// | PHP version 4.1.0 or greater                                         |
// +----------------------------------------------------------------------+
// | Copyright (c) 2000 - 2008 living-e AG                                |
// +----------------------------------------------------------------------+
//


/**
 * @author Thomas Kneip
 * @copyright living-e AG
 */

define ( "SEARCH_TEMP_TABLE", md5(session_id()) );


include_once($_SERVER["DOCUMENT_ROOT"]."/webEdition/we/include/we_classes/" . "we_search.inc.php");
include_once($_SERVER["DOCUMENT_ROOT"]."/webEdition/we/include/" . "we_db_tools.inc.php");
include_once($_SERVER['DOCUMENT_ROOT'].'/webEdition/we/include/we_tools/Suche/language/language_' . $GLOBALS ['WE_LANGUAGE'] . '.inc.php');

class searchtoolsearch extends we_search {
	
	//for doclist!
		/**
		 * @var integer: number of searchfield-rows
		 */
		var $height;
		
		/**
		 * @var string: default order of the result columns
		 */
		var $order = "Text";
		
		/**
		 * @var string: default number of rows of the result columns
		 */
		var $anzahl = 10;
		
		/**
		 * @var string: mode if the searchfields are displayed or not, default = 0 (not displayed)
		 */
		var $mode = 0;
		
		/**
		 * @var string: set view, either iconview (1) or listview (0, default)
		 */
		var $setView = 0;
		
		/**
		 * @var array with fields to search in
		 */
		var $searchFields = array ( );
		
		/**
		 * @var array with operators
		 */
		var $location = array ( );
		
		/**
		 * @var array with fields to search for
		 */
		var $search = array ( );
	

	/**
	 * @abstract get data from fields, used in the doclistsearch
	 */
	function initSearchData() {
		if (isset ( $GLOBALS ['we_doc'] )) {
			$obj = $GLOBALS ['we_doc'];
			
			if (isset ( $_REQUEST ["searchstart"] )) {
				$obj->searchclassFolder->searchstart = ($_REQUEST ["searchstart"]);
			}
			if (isset ( $_REQUEST ["setView"] )) {
				$this->query ( "UPDATE " . FILE_TABLE . " SET listview=" . $_REQUEST ['setView'] . " WHERE ID=" . $obj->ID . "" );
				$obj->searchclassFolder->setView = ($_REQUEST ["setView"]);
			} else {
				$obj->searchclassFolder->setView = f ( "SELECT listview FROM " . FILE_TABLE . " WHERE ID='" . $obj->ID . "'", "listview", $GLOBALS ["DB_WE"] );
			}
			if (isset ( $_REQUEST ["mode"] )) {
				$obj->searchclassFolder->mode = ($_REQUEST ["mode"]);
			}
			if (isset ( $_REQUEST ["order"] )) {
				$obj->searchclassFolder->order = ($_REQUEST ["order"]);
			}
			if (isset ( $_REQUEST ["anzahl"] )) {
				$obj->searchclassFolder->anzahl = ($_REQUEST ["anzahl"]);
			}
			if (isset ( $_REQUEST ["searchFields"] )) {
				$obj->searchclassFolder->searchFields = ($_REQUEST ["searchFields"]);
				$obj->searchclassFolder->height = count ( $_REQUEST ["searchFields"] );
			} elseif (! isset ( $_REQUEST ["searchFields"] ) && isset ( $_REQUEST ["searchstart"] )) {
				$obj->searchclassFolder->height = 0;
			} elseif (! isset ( $_REQUEST ["searchFields"] ) && ! isset ( $_REQUEST ["searchstart"] )) {
				$obj->searchclassFolder->height = 1;
			} else {
				$obj->searchclassFolder->height = 1;
			}
			if (isset ( $_REQUEST ["location"] )) {
				$obj->searchclassFolder->location = ($_REQUEST ["location"]);
			}
			if (isset ( $_REQUEST ["search"] )) {
				$obj->searchclassFolder->search = ($_REQUEST ["search"]);
			}
		} else {
			if (isset ( $_REQUEST ["we_cmd"] ["setView"] ) && isset ( $_REQUEST ["id"] )) {
				$this->query ( "UPDATE " . FILE_TABLE . " SET listview=" . $_REQUEST ["we_cmd"] ["setView"] . " WHERE ID=" . $_REQUEST ["id"] . "" );
			}
		}
	}
	
	function getFields($row, $whichSearch = "") {
		$tableFields = array ('ID' => $GLOBALS ['l_Suche'] ['ID'], 'Text' => $GLOBALS ['l_Suche'] ['Text'], 'Path' => $GLOBALS ['l_Suche'] ['Path'], 'ParentIDDoc' => $GLOBALS ['l_Suche'] ['ParentIDDoc'], 'ParentIDObj' => $GLOBALS ['l_Suche'] ['ParentIDObj'], 'ParentIDTmpl' => $GLOBALS ['l_Suche'] ['ParentIDTmpl'], 'temp_template_id' => $GLOBALS ['l_Suche'] ['temp_template_id'], 'MasterTemplateID' => $GLOBALS ['l_Suche'] ['MasterTemplateID'], 'ContentType' => $GLOBALS ['l_Suche'] ['ContentType'], 'temp_doc_type' => $GLOBALS ['l_Suche'] ['temp_doc_type'], 'temp_category' => $GLOBALS ['l_Suche'] ['temp_category'], 'CreatorID' => $GLOBALS ['l_Suche'] ['CreatorID'], 'CreatorName' => $GLOBALS ['l_Suche'] ['CreatorName'], 'WebUserID' => $GLOBALS ['l_Suche'] ['WebUserID'], 'WebUserName' => $GLOBALS ['l_Suche'] ['WebUserName'], 'Content' => $GLOBALS ['l_Suche'] ['Content'], 'Status' => $GLOBALS ['l_Suche'] ['Status'], 'Speicherart' => $GLOBALS ['l_Suche'] ['Speicherart'], 'Published' => $GLOBALS ['l_Suche'] ['Published'], 'CreationDate' => $GLOBALS ['l_Suche'] ['CreationDate'], 'ModDate' => $GLOBALS ['l_Suche'] ['ModDate'] );
		
		if (! defined ( 'BIG_USER_MODULE' )) {
			unset ( $tableFields ["WebUserID"] );
			unset ( $tableFields ["WebUserName"] );
		}
		
		if ($whichSearch == "doclist") {
			unset ( $tableFields ["Path"] );
			unset ( $tableFields ["ParentIDDoc"] );
			unset ( $tableFields ["ParentIDObj"] );
			unset ( $tableFields ["ParentIDTmpl"] );
			unset ( $tableFields ["MasterTemplateID"] );
		}
		
		if (! we_hasPerm ( 'CAN_SEE_DOCUMENTS' )) {
			unset ( $tableFields ["ParentIDDoc"] );
		}
		
		if (! defined ( 'OBJECT_FILES_TABLE' )) {
			unset ( $tableFields ["ParentIDObj"] );
		}
		
		if (! we_hasPerm ( 'CAN_SEE_OBJECTFILES' )) {
			unset ( $tableFields ["ParentIDObj"] );
		}
		
		if ($_SESSION ["we_mode"] == "seem") {
			unset ( $tableFields ["ParentIDTmpl"] );
		}
		
		if (! we_hasPerm ( 'CAN_SEE_TEMPLATES' )) {
			unset ( $tableFields ["ParentIDTmpl"] );
			unset ( $tableFields ["temp_template_id"] );
			unset ( $tableFields ["MasterTemplateID"] );
		}
		
		return $tableFields;
	}
	
	function getFieldsStatus() {
		
		
		$fields = array ('jeder' => $GLOBALS ['l_Suche'] ['jeder'], 'geparkt' => $GLOBALS ['l_Suche'] ['geparkt'], 'veroeffentlicht' => $GLOBALS ['l_Suche'] ['veroeffentlicht'], 'geaendert' => $GLOBALS ['l_Suche'] ['geaendert'], 'veroeff_geaendert' => $GLOBALS ['l_Suche'] ['veroeff_geaendert'], 'geparkt_geaendert' => $GLOBALS ['l_Suche'] ['geparkt_geaendert'] );
		
		return $fields;
	}
	
	function getFieldsSpeicherart() {
		$fields = array ('jeder' => $GLOBALS ['l_Suche'] ['jeder'], 'dynamisch' => $GLOBALS ['l_Suche'] ['dynamisch'], 'statisch' => $GLOBALS ['l_Suche'] ['statisch'] );
		
		return $fields;
	}
	
	function getLocation($whichField = "") {
		$locations = array ('CONTAIN' => $GLOBALS ['l_Suche'] ['CONTAIN'], 'IS' => $GLOBALS ['l_Suche'] ['IS'], 'START' => $GLOBALS ['l_Suche'] ['START'], 'END' => $GLOBALS ['l_Suche'] ['END'], '<' => $GLOBALS ['l_Suche'] ['<'], '<=' => $GLOBALS ['l_Suche'] ['<='], '>=' => $GLOBALS ['l_Suche'] ['>='], '>' => $GLOBALS ['l_Suche'] ['>'] );
		
		if ($whichField == "date") {
			unset ( $locations ["CONTAIN"] );
			unset ( $locations ["START"] );
			unset ( $locations ["END"] );
		}
		
		return $locations;
	}
	
	function getDoctypes() {
		$_db = new DB_WE ( );
		
		$q = getDoctypeQuery ( $_db );
		$vals = array ( );
		
		$_db->query ( "SELECT * FROM " . DOC_TYPES_TABLE . " $q" );
		while ( $_db->next_record () ) {
			$v = $_db->f ( "ID" );
			$t = $_db->f ( "DocType" );
			$vals [$v] = $t;
		}
		
		return $vals;
	}
	
	function searchInTitle($keyword, $table) {
		$titles = array ( );
		$_db2 = new DB_WE ( );
		//first check published documents
		$query = "SELECT a.Name, b.Dat, a.DID FROM " . LINK_TABLE . " a LEFT JOIN " . CONTENT_TABLE . " b on (a.CID = b.ID) WHERE a.Name='Title' AND b.Dat LIKE '%" . addslashes ( trim ( $keyword ) ) . "%' AND NOT a.DocumentTable='".TEMPLATES_TABLE."'";
		$_db2->query ( $query );
		while ( $_db2->next_record () ) {
			$titles [] = $_db2->f ( 'DID' );	
		}
		//check unpublished documents
		$query2 = "SELECT DocumentID, DocumentObject  FROM " . TEMPORARY_DOC_TABLE . " WHERE 1 AND DocTable = '" . FILE_TABLE . "' AND Active = '1'";
		$_db2->query ( $query2 );
		while ( $_db2->next_record () ) {
			$tempDoc = unserialize ( $_db2->f ( 'DocumentObject' ) );
			if (isset ( $tempDoc [0] ['elements'] ['Title'] ) && $tempDoc [0] ['elements'] ['Title'] ['dat'] != "") {
				$keyword = str_replace("\_", "_", $keyword);
				$keyword = str_replace("\%", "%", $keyword);
				if (stristr ( $tempDoc [0] ['elements'] ['Title'] ['dat'], $keyword )) {
					$titles [] = $_db2->f ( 'DocumentID' );
				}
			}
		}

		$where = "";
		if (!empty ( $titles )) {
			$where = " " . $table . ".ID IN (" . makeCSVFromArray($titles) . ")";
			return $where;
		}
		
		return $where;
	}


function searchCategory($keyword, $table) {
	if ($table != TEMPLATES_TABLE) {
			$userIDs = array ( );
			$_db = new DB_WE ( );
			$_db2 = new DB_WE ( );
			if ($table == FILE_TABLE) {
				$field = "temp_category";
				$field2 = "Category";
			} elseif (defined("OBJECT_TABLE") && $table == OBJECT_TABLE) {
                $field = "DefaultCategory";
            } elseif (defined("OBJECT_FILES_TABLE") && $table == OBJECT_FILES_TABLE) {
                $field = "Category";
            }
			$res = array ( );
			$res2 = array ( );
			
			if ($table == FILE_TABLE) {
				$query = "SELECT ID, " . $field . ", " . $field2 . "  FROM " . $table . " WHERE ((" . $field2 . " != NULL OR " . $field2 . " != '') AND Published >= ModDate AND Published !=0) OR (Published < ModDate AND (" . $field . " != NULL OR " . $field . " != '')) ";
			} 
			elseif (defined("OBJECT_TABLE") && $table == OBJECT_TABLE) {
                $query = "SELECT ID," . $field . "  FROM " . $table . " WHERE " . $field . " != NULL OR " . $field . " != '' ";
            } 
            else {
                $query = "SELECT ID," . $field . "  FROM " . $table . " WHERE " . $field . " != NULL OR " . $field . " != '' AND Published >= ModDate AND Published !=0";
            }
        
			$_db->query( $query );

			if ($table == FILE_TABLE) {
				while ( $_db->next_record () ) {
					if ($_db->f ( $field ) == "") {
						$res [$_db->f ( 'ID' )] = $_db->f ( $field2 );
					} else {
						$res [$_db->f ( 'ID' )] = $_db->f ( $field );
					}
				}
			} 
			elseif (defined("OBJECT_TABLE") && $table == OBJECT_TABLE) {
                while ($_db->next_record()) {
                    $res[$_db->f('ID')] = $_db->f($field);
				}
			} elseif(defined("OBJECT_FILES_TABLE")) {
                 //search in public objects first and write them in the array
				while ( $_db->next_record () ) {
					$res [$_db->f ( 'ID' )] = $_db->f ( $field );
				}
				//search in unpublic objects and write them in the array
				$query2 = "SELECT DocumentObject  FROM " . TEMPORARY_DOC_TABLE . " WHERE DocTable = '" . OBJECT_FILES_TABLE . "' AND Active = '1'";
				$_db2->query ( $query2 );
				while ( $_db2->next_record () ) {
					$tempObj = unserialize ( $_db2->f ( 'DocumentObject' ) );
					if (isset ( $tempObj [0] ["Category"] ) && $tempObj [0] ["Category"] != "") {
						if (! array_key_exists ( $tempObj [0] ["ID"], $res )) {
							$res [$tempObj [0] ["ID"]] = $tempObj [0] ["Category"];
						}
					}
				}
			}

			foreach ( $res as $k => $v ) {
				$res2 [$k] = makeArrayFromCSV ( $v );
			}
			
			$where = "";
			$i = 0;
			
			$keyword = path_to_id ( $keyword, CATEGORY_TABLE );
			
			foreach ( $res2 as $k => $v ) {
				foreach ( $v as $v2 ) {
					//look if the value is numeric
					if (preg_match ( "=^[0-9]+$=i", $v2 )) {
						if ($v2 == $keyword) {
							if ($i > 0) {
								$where .= " OR ";
							} else {
								$where .= " AND (";
							}
							$where .= " " . $table . ".ID = " . $k . "";
							$i ++;
						}
					}
				}
			}
			
			if ($where != "") {
				$where .= " )";
			} else {
				$where .= " 0 ";
			}
			return $where;
		} else {
			return " 0 ";
		}
	}
	
	function searchSpecial($keyword, $searchFields, $searchlocation) {
		$userIDs = array ( );
		$_db = new DB_WE ( );
		if ($searchFields == "CreatorName") {
			$_table = USER_TABLE;
			$field = "Text";
			$fieldFileTable = "CreatorID";
		} elseif ($searchFields == "WebUserName") {
			$_table = CUSTOMER_TABLE;
			$field = "Username";
			$fieldFileTable = "WebUserID";
		}
		
		$query = "SELECT ID FROM " . $_table . " WHERE " . $field . " ";

		if (isset ( $searchlocation )) {
			switch ( $searchlocation) {
				case "END" :
					$searching = " LIKE '%" . addslashes ( $keyword ) . "' ";
				break;
				case "START" :
					$searching = " LIKE '" . addslashes ( $keyword ) . "%' ";
				break;
				case "IS" :
					$searching = " = '" . addslashes ( $keyword ) . "' ";
				break;
				case "<" :
				case "<=" :
				case ">" :
				case ">=" :
					$searching = " " . $searchlocation . " '" . addslashes ( $keyword ) . "' ";
				break;
				default :
					$searching = " LIKE '%" . addslashes ( $keyword ) . "%' ";
				break;
			}
		}
		
		$query .= $searching;

		$_db->query ( $query );
		while ( $_db->next_record () ) {
			$userIDs [] = ($_db->f ( 'ID' ));
		}

		$i = 0;
		$where = "";
		if (! empty ( $userIDs )) {
			foreach ( $userIDs as $id ) {
				if ($i > 0) {
					$where .= " OR ";
				} else {
					$where .= " (";
				}
				
				$where .= $fieldFileTable . " = '" . $id . "' ";
				
				$i ++;
			}
			
			$where .= ")";
		} else {
			$where .= "0";
		}
		
		return $where;
	}
	
	function getStatusFiles($status, $table) {

		$where = "";
		
		switch ($status) {
			case "jeder":
				$where .= "AND (".$table.".ContentType='text/webedition' OR ".$table.".ContentType='text/html' OR ".$table.".ContentType='objectFile')";
			break;
			case "geparkt":
				$where .= "AND ((".$table.".Published=0) AND (".$table.".ContentType='text/webedition' OR ".$table.".ContentType='text/html' OR ".$table.".ContentType='objectFile'))";
			break;
			case "veroeffentlicht":
				$where .= "AND ((".$table.".Published >= ".$table.".ModDate AND ".$table.".Published !=0) AND (".$table.".ContentType='text/webedition' OR ".$table.".ContentType='text/html' OR ".$table.".ContentType='objectFile'))";
			break;
			case "geaendert":
				$where .= "AND ((".$table.".Published < ".$table.".ModDate AND ".$table.".Published !=0) AND (".$table.".ContentType='text/webedition' OR ".$table.".ContentType='text/html' OR ".$table.".ContentType='objectFile'))";
			break;
			case "veroeff_geaendert":
				$where .= "AND ((".$table.".Published >= ".$table.".ModDate OR ".$table.".Published < ".$table.".ModDate AND ".$table.".Published !=0) AND (".$table.".ContentType='text/webedition' OR ".$table.".ContentType='text/html' OR ".$table.".ContentType='objectFile'))";
			break;
			case "geparkt_geaendert":
				$where .= "AND ((".$table.".Published=0 OR ".$table.".Published < ".$table.".ModDate) AND (".$table.".ContentType='text/webedition' OR ".$table.".ContentType='text/html' OR ".$table.".ContentType='objectFile'))";
			break;
			case "dynamisch":
				if ($table != FILE_TABLE) {
					return;
				}
				$where .= "AND ((".$table.".IsDynamic=1) AND (".$table.".ContentType='text/webedition'))";
			break;
			case "statisch":
				if ($table != FILE_TABLE) {
				return;
				}
				$where .= "AND ((".$table.".IsDynamic=0) AND (".$table.".ContentType='text/webedition'))";
			break;
		}
		
		return $where;
	}
	
	function searchContent($keyword, $table) {
	

		$_db = new DB_WE ( );
		$_db2 = new DB_WE ( );
		$contents = array();
		$w = "";
				
		if ($table == FILE_TABLE || $table == TEMPLATES_TABLE) {
		
			$query = "SELECT a.Name, b.Dat, a.DID FROM " . LINK_TABLE . " a LEFT JOIN " . CONTENT_TABLE . " b on (a.CID = b.ID) WHERE b.Dat LIKE '%" . addslashes ( trim ( $keyword ) ) . "%' AND a.Name!='completeData' AND a.DocumentTable='".$table."'";
	        $_db2->query ( $query );
	        while ( $_db2->next_record () ) {
	            $contents [] = $_db2->f ( 'DID' );  
	        }
	        
			if ($table == FILE_TABLE) {
		        $query2 = "SELECT DocumentID, DocumentObject  FROM " . TEMPORARY_DOC_TABLE . " WHERE DocumentObject LIKE '%" . addslashes ( trim ( $keyword ) ) . "%' AND DocTable = '" . $table . "' AND Active = '1'";
		        $_db2->query ( $query2 );
				while ( $_db2->next_record () ) {
	                $contents [] = $_db2->f ( 'DocumentID' );  
	            }
			}
				
			if (!empty($contents)) {
				$w = " " . " " . $table . ".ID IN (" . makeCSVFromArray($contents) . ")";
			} else {
				$w = "";
			}
			
		} elseif (defined ( "OBJECT_FILES_TABLE" ) && $table == OBJECT_FILES_TABLE) {
			
                $_classes = array ();
                $Ids = array();
                $regs = array();
                
                $_db->query ( "SELECT ID FROM " . OBJECT_TABLE . "");
                while ( $_db->next_record () ) {
				    $_classes[] = $_db->f('ID');
                }				
				
				//published objects
				for($i = 1; $i <= count($_classes); $i++) {
					$_obj_table = OBJECT_X_TABLE . $i;
					$_obj_table = strtolower ( $_obj_table );
		            $tableInfo = $_db->metadata($_obj_table);
		            $fields = array();
		            for($c=0;$c<count($tableInfo);$c++){
		                if(ereg('^(.+)_(.+)$',$tableInfo[$c]["name"],$regs)){
		                    if($regs[1]!="OF" && $regs[1]!="variant"){
		                        $fields[] = array("name"=>$tableInfo[$c]["name"],"type"=>$regs[1],"length"=>$tableInfo[$c]["len"]);
		                    }
		                }
		            }
		            $field = array();
		            foreach($fields as $k => $v) {
		            	$field[] = $v['name'];
		            }
		            $where = " ";
		            foreach($field as $k=>$v) {
		            	if($k!=0) {
		            		$where .= " OR ";
		            	}
		            	$where .= $v ." LIKE '%" . addslashes ( trim ( $keyword ) ) . "%' ";
		            }
  
				    $_db->query ( "SELECT " . $_obj_table . ".OF_ID FROM " . $_obj_table . " WHERE " . $where . "" );
                    while ( $_db->next_record () ) {
                        $Ids[] = $_db->f ( 'OF_ID' );
                    }					
					
					
				}
				//unpublished objects
		        $query2 = "SELECT DocumentID, DocumentObject  FROM " . TEMPORARY_DOC_TABLE . " WHERE DocumentObject LIKE '%" . addslashes ( trim ( $keyword ) ) . "%' AND DocTable = '" . OBJECT_FILES_TABLE . "' AND Active = '1'";
		        $_db2->query ( $query2 );
		        while ( $_db2->next_record () ) {
		            $Ids[] = $_db2->f ( 'DocumentID' );  
		        }

		        if (!empty($Ids)) {
                    $w = " " . " " . OBJECT_FILES_TABLE . ".ID IN (" . makeCSVFromArray($Ids) . ")";
                } else {
                    $w = "";
                }
        }
		
		
		return $w;
	}
	
	function getDefaultTableName($name) {
		switch ( $name) {
			case FILE_TABLE :
				return 'tblFile';
			case TEMPLATES_TABLE :
				return 'tblTemplates';
			case OBJECT_TABLE :
				return 'tbObject';
			case OBJECT_FILES_TABLE :
				return 'tblObjectFile';
			case DOC_TYPES_TABLE :
				return 'tblDocTypes';
			case CATEGORY_TABLE :
				return 'tblCategory';
		}
		
		return $name;
	}
	
	function selectFromTempTable($searchstart, $anzahl, $order) {
		$sortIsNr = "DESC";
		$sortNr = "";
		$sortierung = explode ( " ", $order );
		if (isset ( $sortierung [1] )) {
			$sortIsNr = "";
			$sortNr = "DESC";
		}
		
		$query = "SELECT `" . SEARCH_TEMP_TABLE . "`.*,LOWER(".$sortierung [0].") AS lowtext, abs(" . $sortierung [0] . ") as Nr, (" . $sortierung [0] . " REGEXP '^[0-9]') as isNr  FROM `" . SEARCH_TEMP_TABLE . "` ORDER BY IsFolder DESC, isNr ".$sortIsNr.",Nr " . $sortNr . ",lowtext " . $sortNr . ", " .$order. "  limit " . $searchstart . "," . $anzahl . " ";
		$this->query ( $query );
	}
	
	function insertInTempTable($where = "", $table = "") {
		
		$DB_WE = new DB_WE ( );
		$this->table = (empty ( $table )) ? ((empty ( $this->table )) ? "" : $this->table) : $table;
		
		if (! empty ( $this->table )) {
			$this->where = (empty ( $where )) ? ((empty ( $this->where )) ? "" : " WHERE " . $this->where) : " WHERE " . $where;
			
			if ($this->table == FILE_TABLE) {
				$query = "INSERT INTO `" . SEARCH_TEMP_TABLE . "` SELECT '',ID,'" . FILE_TABLE . "',Text,Path,ParentID,IsFolder,temp_template_id,TemplateID,ContentType,'',CreationDate,CreatorID,ModDate,Published,Extension,'' FROM `" . FILE_TABLE . "` " . $this->where . " ";
				$this->query ( $query );
			}
			
			if ($this->table == TEMPLATES_TABLE) {
				$query = "INSERT INTO `" . SEARCH_TEMP_TABLE . "` SELECT '',ID,'" . TEMPLATES_TABLE . "',Text,Path,ParentID,IsFolder,'','',ContentType,'',CreationDate,CreatorID,ModDate,'',Extension,'' FROM `" . TEMPLATES_TABLE . "` " . $this->where . "  ";
				$this->query ( $query );
			}
			
			if (defined ( "OBJECT_FILES_TABLE" ) && $this->table == OBJECT_FILES_TABLE) {
				$query = "INSERT INTO `" . SEARCH_TEMP_TABLE . "` SELECT '',ID,'" . OBJECT_FILES_TABLE . "',Text,Path,ParentID,IsFolder,'','',ContentType,'',CreationDate,CreatorID,ModDate,Published,'',TableID FROM `" . OBJECT_FILES_TABLE . "` " . $this->where . " ";
				$this->query ( $query );
			}
			
			if (defined ( "OBJECT_TABLE" ) && $this->table == OBJECT_TABLE) {
				$query = "INSERT INTO `" . SEARCH_TEMP_TABLE . "` SELECT '',ID,'" . OBJECT_TABLE . "',Text,Path,ParentID,IsFolder,'','',ContentType,'',CreationDate,CreatorID,ModDate,'','','' FROM `" . OBJECT_TABLE . "` " . $this->where . "  ";
				$this->query ( $query );
			}
			
			if ($this->table == FILE_TABLE) {
				
                $_db2 = new DB_WE ( );
                $titles = array();
		        //first check published documents
		        $query = "SELECT a.Name, b.Dat, a.DID FROM `" . LINK_TABLE . "` a LEFT JOIN `" . CONTENT_TABLE . "` b on (a.CID = b.ID) WHERE a.Name='Title' AND NOT a.DocumentTable='".TEMPLATES_TABLE."'";
		        $_db2->query ( $query );
		        while ( $_db2->next_record () ) {
		            $titles [$_db2->f ( 'DID' )] = $_db2->f ( 'Dat' );
		        }
		        //check unpublished documents
		        $query2 = "SELECT DocumentID, DocumentObject  FROM `" . TEMPORARY_DOC_TABLE . "` WHERE 1 AND DocTable = '" . FILE_TABLE . "' AND Active = '1'";
		        $_db2->query ( $query2 );
		        while ( $_db2->next_record () ) {
		            $tempDoc = unserialize ( $_db2->f ( 'DocumentObject' ) );
		            if (isset ( $tempDoc [0] ['elements'] ['Title'] )) {
		               $titles [$_db2->f ( 'DocumentID' )] = $tempDoc [0] ['elements'] ['Title'] ['dat'];  
		            }
		        }
		        if(is_array($titles) && !empty($titles)) {
	                foreach($titles as $k => $v) {
	                	if($v!="") {
		                	$query3 = "UPDATE `" . SEARCH_TEMP_TABLE . "` SET `SiteTitle` = '" . $v . "' WHERE docID = '" . $k . "' AND DocTable = '" . FILE_TABLE . "' LIMIT 1 ";
		                    $DB_WE->query ( $query3 );
	                	}
	                }
			    }
			}
		}
	}
	
	function getTableType() {
		
		$tableType = "HEAP";
		if(getMysqlVer()<4100) {
			$tableType = "MYISAM";
		}
		return $tableType;
	}
	
	function createTempTable() {
		
		$q = "DROP TABLE IF EXISTS `" . SEARCH_TEMP_TABLE . "`";
		$this->query ( $q );
		
		$tableType = searchtoolsearch::getTableType();
		
		$tempTableTrue = ($this->checkRightTempTable()=="0") ? "TEMPORARY" : "";
		
		if($this->checkRightDropTable()=="1" && $tempTableTrue=="") {
		}
		else {
			
			$q = "
				 CREATE ".$tempTableTrue." TABLE `" . SEARCH_TEMP_TABLE . "` (
				`ID` BIGINT( 20 ) NOT NULL AUTO_INCREMENT PRIMARY KEY ,
				`docID` BIGINT( 20 ) NOT NULL ,
				`docTable` VARCHAR( 32 ) NOT NULL ,
				`Text` VARCHAR( 255 ) NOT NULL ,
				`Path` VARCHAR( 255 ) NOT NULL ,
				`ParentID` BIGINT( 20 ) NOT NULL ,
				`IsFolder` TINYINT( 1 ) NOT NULL ,
				`temp_template_id` INT( 11 ) NOT NULL ,
				`TemplateID` INT( 11 ) NOT NULL ,
				`ContentType` VARCHAR( 32 ) NOT NULL ,
				`SiteTitle` VARCHAR( 255 ) NOT NULL ,
				`CreationDate` INT( 11 ) NOT NULL ,
				`CreatorID` BIGINT( 20 ) NOT NULL ,
				`ModDate` INT( 11 ) NOT NULL ,
				`Published` INT( 11 ) NOT NULL ,
				`Extension` VARCHAR( 16 ) NOT NULL ,
				`TableID` INT( 11 ) NOT NULL
				) TYPE = ".$tableType."
			";
	
			$this->query ( $q );
		
		}

	}
	
	function searchfor($searchname, $searchfield, $searchlocation, $tablename) {
		$operator = " AND ";
		$this->table = $tablename;
		$sql = "";
		$tableInfo = $GLOBALS ["DB_WE"]->metadata ( $this->table );
		
		$whatParentID = "";
		
		if ($searchfield == "ParentIDDoc" || $searchfield == "ParentIDObj" || $searchfield == "ParentIDTmpl") {
			$whatParentID = $searchfield;
			$searchfield = "ParentID";
		}
		
		if ($searchfield == "ID" || $searchfield == "CreatorID" || $searchfield == "WebUserID") {
			if (! is_numeric ( $searchname )) {
				return " AND 0";
			}
		}
		
		//filter fields for each table
		for($y = 0; $y < sizeof ( $tableInfo ); $y ++) {
			if ($searchfield == $tableInfo [$y] ["name"]) {
				$searchfield = $tablename . "." . $tableInfo [$y] ["name"];
				
				if (isset ( $searchname ) && $searchname != "")
					if (($whatParentID == "ParentIDDoc" && $this->table == FILE_TABLE) || ($whatParentID == "ParentIDObj" && $this->table == OBJECT_FILES_TABLE) || ($whatParentID == "ParentIDTmpl" && $this->table == TEMPLATES_TABLE)) {
						$searchname = path_to_id ( $searchname, $this->table );
						$searching = " = '" . addslashes ( $searchname ) . "' ";
						$sql .= $this->sqlwhere ( $searchfield, $searching, $operator );
					} elseif (($searchfield == TEMPLATES_TABLE.".MasterTemplateID" && $this->table == TEMPLATES_TABLE) || ($searchfield == FILE_TABLE.".temp_template_id" && $this->table == FILE_TABLE)) {
						$searchname = path_to_id ( $searchname, TEMPLATES_TABLE );
						$searching = " = '" . addslashes ( $searchname ) . "' ";
						
						if ($searchfield == "temp_template_id" && $this->table == FILE_TABLE) {
							$sql .= $this->sqlwhere ( $tablename . ".TemplateID", $searching, $operator . "( (Published >= ModDate AND Published !=0 AND " );
							$sql .= $this->sqlwhere ( $searchfield, $searching, " ) OR (Published < ModDate AND " );
							$sql .= ")) ";
							
						} else {
							$sql .= $this->sqlwhere ( $searchfield, $searching, $operator );
						}
					} elseif ($searchfield == "temp_doc_type" && $this->table == FILE_TABLE) {
						$searching = " = '" . addslashes ( $searchname ) . "' ";
						
						$sql .= $this->sqlwhere ( $tablename . ".DocType", $searching, $operator . "( (Published >= ModDate AND Published !=0 AND " );
						$sql .= $this->sqlwhere ( $searchfield, $searching, " ) OR (Published < ModDate AND " );
						$sql .= "))";
					} elseif (stristr ( $searchfield, ".Published" ) || stristr ( $searchfield, ".CreationDate" ) || stristr ( $searchfield, ".ModDate" )) {
						if ((stristr ( $searchfield, ".Published" ) && $this->table == FILE_TABLE || $this->table == OBJECT_FILES_TABLE) || ! stristr ( $searchfield, ".Published" )) {
							$date = explode ( ".", $searchname );
							$day = $date [0];
							$month = $date [1];
							$year = $date [2];
							$timestampStart = mktime ( 0, 0, 0, $month, $day, $year );
							$timestampEnd = mktime ( 23, 59, 59, $month, $day, $year );
							
							if (isset ( $searchlocation )) {
								switch ( $searchlocation) {
									case "IS" :
										$searching = " BETWEEN " . $timestampStart . " AND " . $timestampEnd . " ";
										$sql .= $this->sqlwhere ( $searchfield, $searching, $operator );
									break;
									case "<" :
										$searching = " " . $searchlocation . " '" . $timestampStart . "' ";
										$sql .= $this->sqlwhere ( $searchfield, $searching, $operator );
									break;
									case "<=" :
										$searching = " " . $searchlocation . " '" . $timestampEnd . "' ";
										$sql .= $this->sqlwhere ( $searchfield, $searching, $operator );
									break;
									case ">" :
										$searching = " " . $searchlocation . " '" . $timestampEnd . "' ";
										$sql .= $this->sqlwhere ( $searchfield, $searching, $operator );
									break;
									case ">=" :
										$searching = " " . $searchlocation . " '" . $timestampStart . "' ";
										$sql .= $this->sqlwhere ( $searchfield, $searching, $operator );
									break;
								}
							}
						}
					} else 

					{
						if (isset ( $searchlocation )) {
							switch ( $searchlocation) {
								case "END" :
									$searching = " LIKE '%" . addslashes ( $searchname ) . "' ";
									$sql .= $this->sqlwhere ( $searchfield, $searching, $operator );
								break;
								case "START" :
									$searching = " LIKE '" . addslashes ( $searchname ) . "%' ";
									$sql .= $this->sqlwhere ( $searchfield, $searching, $operator );
								//$sql .= " ".$val["field"]." LIKE ".$val["search"]."% ";
								break;
								case "IS" :
									$searching = " = '" . addslashes ( $searchname ) . "' ";
									$sql .= $this->sqlwhere ( $searchfield, $searching, $operator );
								break;
								case "<" :
								case "<=" :
								case ">" :
								case ">=" :
									$searching = " " . $searchlocation . " '" . addslashes ( $searchname ) . "' ";
									$sql .= $this->sqlwhere ( $searchfield, $searching, $operator );
								break;
								default :
									$searching = " LIKE '%" . addslashes ( $searchname ) . "%' ";
									$sql .= $this->sqlwhere ( $searchfield, $searching, $operator );
								break;
							}
						}
					}
			}
		}
		
		return $sql;
	}
	
	function ofFolderAndChildsOnly($folderID, $table) {
		
		$_SESSION["Suche"]["countChilds"] = array();
		$childsOfFolderId = array ( );
		//fix #2940
		if(is_array($folderID)) {
			if(!empty($folderID)) {
				foreach($folderID as $k) {
					$childsOfFolderId = $this->getChildsOfParentId ( $k, $table );
					$ids = makeCSVFromArray ( $childsOfFolderId );
				}
				return ' AND '.$table.'.ParentID IN (' . $ids . ')';
			}
		}
		else {
			$childsOfFolderId = $this->getChildsOfParentId ( $folderID, $table );
			$ids = makeCSVFromArray ( $childsOfFolderId );
		
			return ' AND '.$table.'.ParentID IN (' . $ids . ')';
		}
	}
	
	function getChildsOfParentId($folderID, $table) {
		$DB_WE = new DB_WE ( );
		
		$query = "SELECT ID FROM `".$table."` WHERE ParentID='" . $folderID . "' AND IsFolder='1' ";
		$DB_WE->query ( $query );
		while ( $DB_WE->next_record () ) {
			$_SESSION["Suche"]["countChilds"] [] = $DB_WE->f ( "ID" );
			$this->getChildsOfParentId ( $DB_WE->f ( "ID" ), $table );
		}
		
		$_SESSION["Suche"]["countChilds"] [] = $folderID;
		// doppelte Eintrge aus array entfernen
		$_SESSION["Suche"]["countChilds"] = array_values ( array_unique ( $_SESSION["Suche"]["countChilds"] ) );

		return $_SESSION["Suche"]["countChilds"];
	}
	
	function ofFolderOnly($folderID) {
		return ' AND ParentID = '.$folderID;
			
	}
	
	function checkRightTempTable() {
		$db = new DB_WE();		
		$tableType = searchtoolsearch::getTableType();
		$rights = "
			   CREATE TEMPORARY TABLE `test_".SEARCH_TEMP_TABLE."` (
				`test` VARCHAR( 1 ) NOT NULL
				) TYPE=".$tableType." 
		";
		$db->query ( $rights );
		$db->next_record();

//		if(isset($db->Record[0]) && (stristr(($db->Record[0]),"CREATE TEMPORARY TABLES")!="" || stristr(($db->Record[0]),"ALL PRIVILEGES")!="")) {
//			return "0";
//		}
		$return = "0";

		if(stristr($db->Error,"Access denied")) {
			$return = "1";
		}
		
		$q = "DROP TABLE IF EXISTS `test_".SEARCH_TEMP_TABLE."`";
		$db->query ( $q );
		
		return $return;
	}
	
	function checkRightDropTable() {
		$db = new DB_WE();		
		$tableType = searchtoolsearch::getTableType();
		$rights = "
			   CREATE TABLE `test_".SEARCH_TEMP_TABLE."` (
				`test` VARCHAR( 1 ) NOT NULL
				) TYPE=".$tableType." 
		";
		$db->query ( $rights );
		$db->next_record();

//		if(isset($db->Record[0]) && (stristr(($db->Record[0]),"CREATE TEMPORARY TABLES")!="" || stristr(($db->Record[0]),"ALL PRIVILEGES")!="")) {
//			return "0";
//		}
		$return = "0";
		
		$q = "DROP TABLE IF EXISTS `test_".SEARCH_TEMP_TABLE."`";
		$db->query ( $q );

		if(stristr($db->Error,"command denied")) {
			$return = "1";
		}
		
		
		
		return $return;
	}

}

?>
