<?php
			

include_once($_SERVER['DOCUMENT_ROOT'] . '/webEdition/we/include/we_classes/base/weFile.class.php');
include_once($_SERVER['DOCUMENT_ROOT'] . '/webEdition/we/include/we_classes/tools/weToolModel.class.php');

class weToolItem extends weToolModel {

	/**
	* Default Constructor
	* Can load or create new weToolItem object depends of parameter
	*/
	
	var $ModelClassName = "weToolItem";
	var $Icon = "toolfactory.gif";
	var $toolName = "toolfactory";
	
	
	var $persistent_slots = array('name','classname','maintable','datasource','makeTable','makeTags','makeServices','makePerms','makeBackup');
	var $requiredFields = array('name','classname');
	
	var $name = '';
	var $classname = '';
	var $maintable = '';
	var $datasource = 'custom:';
	
	
	var $makeTable = 0;
	var $makeTags = 1;
	var $makeServices = 1;
	var $makePerms = 1;
	var $makeBackup = 1;
	
	var $tags = array();
	var $services = array();
	var $languages = array();
	var $permissions = array();
	var $backupTables = array();
	
	function weToolItem($toolfactoryID=''){

		if ($toolfactoryID){
			$this->ID=$toolfactoryID;
			$this->load($toolfactoryID);
		}

	}
	
	
	function filenameNotValid() {
		return eregi('[^a-z0-9_\-]',$this->name);
	}
	
	function fileclassnameNotValid() {
		return eregi('[^a-z0-9_\-]',$this->classname);
	}
	
	function maintablenameNotValid() {
		return eregi('[^a-z0-9_\-]',$this->maintable);
	}
	
	function maintablenameExists($tab) {
			global $DB_WE;
			$DB_WE->query("SHOW TABLES LIKE '$tab';");
			if($DB_WE->next_record()) return true; else return false;
	}
	
	function modelclassExists($classname) {
		
	$_menuItems = weToolLookup::getAllTools(true);

		$_prohibit_classnames = array($_menuItems);
		
		foreach ($_menuItems as $_menuItem) {

			$_prohibit_classnames[] = $_menuItem["classname"];
						
		}

		if(in_array($classname,$_prohibit_classnames)) {
			return true;
		}
		else return false;
		
	}
	
	function toolExists($name){
		
		$_menuItems = weToolLookup::getAllTools(true);
		
		$_prohibit_names1 = array();
		
		foreach ($_menuItems as $_menuItem) {

			$_prohibit_names1[] = $_menuItem["name"];
			
			if($_menuItem["name"]!=$_menuItem["text"]) {
				$_prohibit_names1[] = $_menuItem["text"];
			}
			
		}
		
		$_prohibit_names2 = array('','.','..','cvs','cache','doctype','search','first_steps_wizard','navigation','toolfactory');
		
		foreach ($_prohibit_names2 as $names) {
			if(!in_array($names, $_prohibit_names1)) {
				$_prohibit_names1[] = $names;
			}
		}

		if(in_array($name,$_prohibit_names1)) {
			return true;
		}
		else return false;
	}	
	
	
	function load($id) {
		
		$_props = weToolLookup::getToolProperties($id);
		
		foreach ($_props as $_key=>$_prop) {
			$this->$_key = $_prop;
		}
		
		$this->ID = $this->name;

		$this->tags = weToolLookup::getAllToolTags($id);
		
		$this->services = weToolLookup::getAllToolServices($id);
		
		$this->languages = weToolLookup::getAllToolLanguages($id);
		
		$this->backupTables = weToolLookup::getBackupTables($id);
		
		if(file_exists(WE_TOOLS_DIR . $this->name . '/conf/permission.conf.php')) {
			include(WE_TOOLS_DIR . $this->name . '/conf/permission.conf.php');
			$this->permissions = $perm_defaults[$perm_group_name];
		}
		
	}
	
	function getNewFileName($name,$TOOLNAME,$CLASSNAME) {
		
		$_newname = str_replace("TOOLNAME",$TOOLNAME,$name);
		
		$_newname = str_replace("CLASSNAME",$CLASSNAME,$_newname);
		
		return $_newname;
	}
	
	function save() {
		
		$TOOLNAME = $this->name;
		$CLASSNAME = $this->classname;
		$TABLENAME = $this->maintable;
		$TABLECONSTANT = !empty($this->maintable) ? strtoupper($this->name) . '_TABLE' : '';
		$DATASOURCE = !empty($this->maintable) ? 'table:' . $this->table : 'custom:';
		
		if($this->makePerms) {
			$PERMISSIONCONDITION = 'EDIT_' . strtoupper($this->name);
			$DELETECONDITION = 'DELETE_' . strtoupper($this->name);
		} else {
			$PERMISSIONCONDITION = '';
			$DELETECONDITION = '';
		}
		
		$_prohibit_names = array('navigation','doctype','first_steps_wizard','search','cache','toolfactory','Suche');
		
		if(in_array($TOOLNAME,$_prohibit_names)) {
			die('The name ' . $TOOLNAME . ' is prohibit');
		}
	
		$_templateDir = $_SERVER['DOCUMENT_ROOT'] . '/webEdition/we/include/we_tools/toolfactory/pattern';
		
		$_toolDir = WE_TOOLS_DIR . '/' . $TOOLNAME . '/';
		
		$_files = array();
		
		weToolLookup::getFilesOfDir($_files,$_templateDir);
	
		foreach ($_files as $_file) {
			
			$_newname = str_replace($_templateDir,WE_TOOLS_DIR . $TOOLNAME ,$_file);
			$_newname = dirname($_newname) . '/' . $this->getNewFileName(basename($_newname),$TOOLNAME,$CLASSNAME);
			
			if($this->shouldInclude($_newname)) {
			
				$_ext = substr($_file,-4);
				$is_php = $_ext=='.php' ? true : false;
				
				if(!$is_php) {
					if($_ext=='.sql') {
						ob_start();
						include($_file);
						$_content = ob_get_contents();
						ob_end_clean();
					} else {
						$_content = weFile::load($_file);
					}
				} else {
					$_content = '<?php
					';
					ob_start();
					include($_file);
					$_content .= ob_get_contents();
					ob_end_clean();
					$_content .= '
		?>';
				}
				
		
				if(!is_dir(dirname($_newname))) {
					//print "Create folder " . dirname($_newname) . "<br>";
					
					if(!is_dir(dirname($_newname))) {
						$path = dirname($_newname);
						$pathteile = explode("/", $path) ;
						$path = "";
						 for ($i=1; $i < count($pathteile); $i++) {
					         $path .= "/". $pathteile[$i];
					         if(!is_dir($path)) {
					         	mkdir($path, 0777);
					         }
						}
					}
					
				}
				//print "Saving file " . $_newname . "...<br>";
				weFile::save($_newname,$_content);
			}
		}
		
		if($this->makeTable) {
			$_sqlDumpFile = WE_TOOLS_DIR . $TOOLNAME . '/' . $TOOLNAME . '.sql';
			$_sqlDump = file($_sqlDumpFile);
			$_db = new DB_WE();
			foreach ($_sqlDump as $_sql) {
				//print "Execute query " . $_sql . "...<br>";
				$_db->query($_sql);
			}		
		}
		
		$this->ID = $this->name;
		
		return true;
			
	}
	
	function shouldInclude($file) {
		
		$_dn = dirname($file);
		$_bn = basename($file);
		
		if($_bn!=$this->name . '.sql' && $_bn!='permission.conf.php' && $_bn!='backup.conf.php' && $_dn!=WE_TOOLS_DIR . $this->name . '/tags' && $_dn!=WE_TOOLS_DIR . $this->name . '/service/cmds' && $_dn!=WE_TOOLS_DIR . $this->name . '/service/views/json' && $_dn!=WE_TOOLS_DIR . $this->name . '/service/views/text') {
			return true;
		}
		
		
		if($this->makePerms && $_bn=='permission.conf.php') {
			return true;
		}
		if($this->makeBackup && $_bn=='backup.conf.php') {
			return true;
		}
		
		if($this->makeTags && ($_dn==WE_TOOLS_DIR . $this->name . '/tags')) {
			return true;
		}
		
		if($this->makeServices && ($_dn==WE_TOOLS_DIR . $this->name . '/service/cmds' || $_dn==WE_TOOLS_DIR . $this->name . '/service/views')) {
			return true;
		}
		
		if($this->makeServices && ($_dn==WE_TOOLS_DIR . $this->name . '/service/views/text' || $_dn==WE_TOOLS_DIR . $this->name . '/service/views/json')) {
			return true;
		}
		
		if($this->makeTable && $_bn==$this->name . '.sql') {
			return true;
		}
		
		return false;
		
	}
	
	
	function setIsFolder($value) {
		$this->IsFolder = $value;
		if($value) {
			$this->Icon = 'folder.gif';
		} else {
			$this->Icon = 'toolfactory.gif';
		}
	}
	
	
	function delete() {
		
		$_files = array();
		$_toolDir = WE_TOOLS_DIR . $this->name;
		
		weToolLookup::getFilesOfDir($_files,$_toolDir);
		
		foreach ($_files as $_file) {
			@unlink($_file);
		}
		
		$_dirs = array();
		weToolLookup::getDirsOfDir($_dirs,$_toolDir);
		rsort($_dirs);
		$_dirs[] = $_toolDir;
		foreach ($_dirs as $_dir) {
			if(!@rmdir($_dir)) error_log('Failed to delete: ' . $_dir);
		}
		
		return true;
	}
	
	
}

?>